<template>
	<form @submit.prevent="onSubmit">
		<strong><label for="taxon ">Taxon</label></strong>
		<div class="row">
			<div class="form-group col-sm-8">
				<input
					type="text"
					id="taxon"
					v-model="taxon"
					placeholder="Search taxons..."
					class="form-control"
				/>
			</div>
			<div class="form-group col-sm-4">
				<select
					name="search-option"
					v-model="option"
					id="search-option"
					class="form-control"
				>
					<option value="icontains">Includes</option>
					<option value="istartswith">Starts with</option>
					<option value="iendswith">Ends with</option>
				</select>
			</div>
		</div>

		<strong><label for="rank">Rank</label></strong>
		<div class="row">
			<div class="form-group col-sm-8">
				<input
					type="text"
					id="rank"
					v-model="rank"
					placeholder="Define rank..."
					class="form-control"
				/>
			</div>
			<div class="form-group col-sm-4">
				<select
					name="rank-option"
					v-model="rankOption"
					id="rank-option"
					class="form-control"
				>
					<option value="true">Include</option>
					<option value="false">Exclude</option>
				</select>
			</div>
		</div>

		<div class="row">
			<div class="col-sm-8">
				<div class="row">
					<div class="form-group col">
						<strong><label for="author">Author</label></strong>
						<input
							type="text"
							id="author"
							v-model="author"
							placeholder="Define author..."
							class="form-control"
						/>
					</div>
				</div>
				<div class="row">
					<div class="col">
						<div class="" id="location">
							<strong><label for="location">Location</label></strong>
						</div>
						<div class="form-check-inline">
							<input
								v-model="inEstonia"
								class="form-check-input"
								type="checkbox"
								value=""
								id="Estonia"
							/>
							<label class="form-check-label" for="Estonia">
								In Estonia
							</label>
						</div>
						<div class="form-check-inline">
							<input
								v-model="inBaltoscandia"
								class="form-check-input"
								type="checkbox"
								value=""
								id="Baltoscandia"
							/>
						</div>
						<label class="form-check-label" for="Baltoscandia">
							In Baltoscandia
						</label>
					</div>
				</div>
			</div>

			<div class="col-sm-4">
				<div class="row">
					<div class="form-group col">
						<strong><label for="author-year">Author year</label></strong>
						<input
							type="number"
							id="author-year"
							v-model="authorYear"
							placeholder="Year"
							class="form-control"
						/>
					</div>
				</div>
				<div class="row">
					<div class="form-group col">
						<strong><label for="parent-year">Parent author year</label></strong>
						<input
							type="number"
							id="parent-year"
							v-model="parentYear"
							placeholder="Year"
							class="form-control"
						/>
					</div>
				</div>
			</div>
		</div>

		<div class="row pt-3">
			<div class="col text-center">
				<div>
					<button type="submit" class="btn btn-light px-4" :disabled="isDisabled">
						<template v-if="loading">
							<span
								class="spinner-border spinner-border-sm"
								role="status"
								aria-hidden="true"
							></span>
							Loading...
						</template>
						<span v-else>Search taxon</span>
					</button>
				</div>
			</div>
		</div>
	</form>
</template>

<script>
export default {
	name: "SearchTaxon",
	data() {
		return {
			taxon: "",
			option: "icontains",
			author: "",
			authorYear: "",
			parentYear: "",
			inEstonia: true,
			inBaltoscandia: true,
			rank: "",
			rankOption: "true",
			loading: false
		};
	},
	computed: {
		isDisabled: function() {
			return this.loading;
		}
	},
	methods: {
		onSubmit() {
			this.$emit("search-text", {
				taxon: this.taxon,
				option: this.option,
				author: this.author,
				authorYear: this.authorYear,
				parentYear: this.parentYear,
				inEstonia: this.inEstonia,
				inBaltoscandia: this.inBaltoscandia,
				rank: this.rank,
				rankOption: this.rankOption
			});
			/* 
      // Reset state after search
      this.text = "";
			this.option = "icontains";
			this.inEstonia = true;
      this.inBaltoscandia = true; 
      */
		}
	}
};
</script>

<style></style>
